/*
 * BlastResult.h
 *
 *  Created on: 2013/01/09
 *      Author: Axiohelix
 */

#include <string>

#ifndef BLASTRESULT_H_
#define BLASTRESULT_H_

class BlastResult {
	private:
		/* ID. */
		std::string m_id;
		/* % identity */
		double m_identity;
		/* alignment length */
		int m_alignmentLength;
		/* mismatches */
		int m_mismatches;
		/* gap openings */
		int m_gap;
		/* e-value */
		double m_evalue;
		/* bit score */
		double m_score;

		/* taxonomy id. */
		int m_taxonomyId;

	public:
		BlastResult();
		virtual ~BlastResult();

		inline std::string getId() const { return m_id; }
		inline void setId(std::string id) { m_id = id; }

		inline double getIdentity() const { return m_identity; }
		inline void setIdentity(double identity) { m_identity = identity; }

		inline int getAlignmentLength() const { return m_alignmentLength; }
		inline void setAlignmentLength(int alignmentLength) { m_alignmentLength = alignmentLength; }

		inline int getMismatches() const { return m_mismatches; }
		inline void setMismatches(int mismatches) { m_mismatches = mismatches; }

		inline int getGap() const { return m_gap; }
		inline void setGap(int gap) { m_gap = gap; }

		inline double getEvalue() const { return m_evalue; }
		inline void setEvalue(double evalue) { m_evalue = evalue; }

		inline double getScore() const { return m_score; }
		inline void setScore(double score) { m_score = score; }

		inline int getTaxonomyId() const { return m_taxonomyId; }
		inline void setTaxonomyId(int taxonomyId) { m_taxonomyId = taxonomyId; }
};

#endif /* BLASTRESULT_H_ */
