/*
 * KeggGene.cpp
 *
 *  Created on: 2013/01/09
 *      Author: Axiohelix
 */

#include <vector>
#include <algorithm>

#include "KeggGene.h"

#include "USCG.h"

#include "Splitter.h"

KeggGene::~KeggGene() {
	if(m_koVec != NULL) {
		delete m_koVec;
	}
}

void KeggGene::SetTaxonomy(int gi, std::map<int, int>* giTaxidMap, std::map<int, TaxonomyNode>* taxNodeMap) {
	if(gi > 0) {
		if((*giTaxidMap).find(gi) != (*giTaxidMap).end()) {
			if((*taxNodeMap).find((*giTaxidMap)[gi]) != (*taxNodeMap).end()) {
				m_taxNode = &((*taxNodeMap)[(*giTaxidMap)[gi]]);
			}
		}
	}
}

void KeggGene::SetKeggOrtholog(std::string _ko, std::map<std::string, KO>* koMap, std::map<std::string, USCG*>* uscgMap) {
	if(_ko.length() == 0) {
		return;
	}

	static Splitter koSplitter;

	koSplitter.setStr(_ko, ",");
	std::vector<std::string> koVec = koSplitter.split();
	for(std::vector<std::string>::iterator itr = koVec.begin(); itr != koVec.end(); itr++) {
		std::string ko = "ko:" + *itr;

		if((*koMap).find(ko) != (*koMap).end()) {
			AddKo(&((*koMap)[ko]));
		} else {
			(*koMap).insert(std::pair<std::string, KO>(ko, KO(ko)));
		}

		if((*uscgMap).find((*koMap)[ko].GetId()) != (*uscgMap).end()) {
			((*uscgMap)[(*koMap)[ko].GetId()])->AddGene(this);
		}
	}
}

void KeggGene::AddKo(KO *ko) {
	if(m_koVec == NULL) {
		m_koVec = new std::vector<KO *>;
	}

	if(find(m_koVec->begin(), m_koVec->end(), ko) == m_koVec->end()) {
		m_koVec->push_back(ko);
	}
}
