/*
 * Splitter.h
 *
 *  Created on: 2010/12/08
 *      Author: Axiohelix
 */

#ifndef SPLITTER_H_
#define SPLITTER_H_

#include	<string>
#include	<vector>

/**
 * 与えられた文字列を与えられたデリミタにより分割するメソッドを提供するクラス.
 * strtokが連続したデリミタをまとめてしまうために、添え字がずれることに対応するための自作クラス.
 */
class Splitter {
	private:
		/* 開始位置 */
		/* size_tなのはstring.findの戻り値と比較するため. */
		size_t m_startPos;
		/* 分割対象文字列 */
		std::string m_str;
		/* デリミタ */
		/* 複数のデリミタに対応するためvectorクラスで保持する. */
		std::vector<std::string> m_delimVector;

		/* 分割が終わったかどうか */
		bool m_isEnd;

	public:
		/* コンストラクタ・デストラクタ */
		Splitter();
		Splitter(const std::string, const std::string);
		Splitter(const std::string, const std::vector<std::string>);
		virtual ~Splitter();

		/* 分割対象文字列をセットするsetter */
		void setStr(const std::string);
		void setStr(const std::string, const std::string);
		void setStr(const std::string, const std::vector<std::string>);

		/* メソッド群*/
		std::vector<std::string> split();
		std::string next();

		/* 分割が終了したかを得るgetter */
		bool isEnd() { return m_isEnd; };
};

#endif /* SPLITTER_H_ */
