/*
 * USCG.h
 *
 *  Created on: 2013/01/09
 *      Author: Axiohelix
 */

#ifndef USCG_H_
#define USCG_H_

#include	<string>
#include	<vector>
#include	<algorithm>

class KeggGene;

/**
 * USCGの情報を格納するオブジェクト.
 */
class USCG {
	private:
		/* KO definition */
		std::string m_def;
		/* KO ID */
		std::string m_ko;

		std::vector<KeggGene *> m_geneVec;

	public:
		/* コンストラクタ・デストラクタ */
		USCG() { };
		USCG(const std::string ko, const std::string def) {
			m_ko = ko;
			m_def = def;
		};
		virtual ~USCG() { };

		/* setter / getter */
		inline const std::string GetKo() { return m_ko; }
		inline const std::string GetDef() { return m_def; }

		inline void AddGene(KeggGene *gene) { if(find(m_geneVec.begin(), m_geneVec.end(), gene) == m_geneVec.end()) { m_geneVec.push_back(gene); } };
		inline std::vector<KeggGene *> *GetGeneVec() { return &m_geneVec; };
};

#endif /* USCG_H_ */
